scala.tools.nsc.typechecker

# Unapplies

#### trait Unapplies extends TreeDSL

Self Type
  Analyzer
Source
  Unapplies.scala

Linear Supertypes
TreeDSL, AnyRef, Any
Known Subclasses
Analyzer, Duplicator, Duplicators, Erasure, SpecializationDuplicator, TreeCheckers, erasure, treeChecker
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Unapplies
2. TreeDSL
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class ClassForCaseCompanionAttachment extends AnyRef

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     TreeDSL

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Unapplies to any2stringadd[Unapplies] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Unapplies, B)

   Implicit information
     This member is added by an implicit conversion from Unapplies to ArrowAssoc[Unapplies] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### object CODE

   Definition Classes
     TreeDSL

7. #### object HasUnapply

8. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

9. #### def caseClassCopyMeth(cdef: Global.ClassDef): Option[Global.DefDef]

   Generates copy methods for case classes.

   Generates copy methods for case classes. Copy only has defaults on the first parameter list, as of SI-5009.

   The parameter types of the copy method need to be exactly the same as the parameter types of the primary constructor. Just copying the TypeTree is not enough: a type `C` might refer to something else *inside* the class (i.e. as parameter type of `copy`) than *outside* the class (i.e. in the class parameter list).

   One such example is t0054.scala: class A { case class B(x: C) extends A { def copy(x: C = x) = ... } class C {} } (1) (2)

   The reference (1) to C is `A.this.C`. The reference (2) is `B.this.C` - not the same.

   This is fixed with a hack currently. `Unapplies.caseClassCopyMeth`, which creates the copy method, uses empty `TypeTree()` nodes for parameter types.

   In `Namers.enterDefDef`, the copy method gets a special type completer (`enterCopyMethod`). Before computing the body type of `copy`, the class parameter types are assigned the copy method parameters.

   This attachment class stores the copy method parameter ValDefs as an attachment in the ClassDef of the case class.

10. #### def caseModuleApplyMeth(cdef: Global.ClassDef): Global.DefDef

    The apply method corresponding to a case class

11. #### def caseModuleDef(cdef: Global.ClassDef): Global.ModuleDef

    The module corresponding to a case class; overrides toString to show the module's name

12. #### def caseModuleUnapplyMeth(cdef: Global.ClassDef): Global.DefDef

    The unapply method corresponding to a case class

13. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

14. #### def companionModuleDef(cdef: Global.ClassDef, parents: List[Global.Tree] = Nil, body: List[Global.Tree] = Nil): Global.ModuleDef

15. #### def directUnapplyMember(tp: Global.Type): Global.Symbol

    Returns unapply or unapplySeq if available, without further checks.

16. #### def ensuring(cond: (Unapplies) ⇒ Boolean, msg: ⇒ Any): Unapplies

    Implicit information
      This member is added by an implicit conversion from Unapplies to Ensuring[Unapplies] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: (Unapplies) ⇒ Boolean): Unapplies

    Implicit information
      This member is added by an implicit conversion from Unapplies to Ensuring[Unapplies] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean, msg: ⇒ Any): Unapplies

    Implicit information
      This member is added by an implicit conversion from Unapplies to Ensuring[Unapplies] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: Boolean): Unapplies

    Implicit information
      This member is added by an implicit conversion from Unapplies to Ensuring[Unapplies] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

21. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

22. #### def factoryMeth(mods: Global.Modifiers, name: Global.TermName, cdef: Global.ClassDef): Global.DefDef

    The apply method corresponding to a case class

23. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

24. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Unapplies to StringFormat[Unapplies] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

25. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

26. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

27. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

28. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

29. #### final def notify(): Unit

    Definition Classes
      AnyRef

30. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

31. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

32. #### def toString(): String

    Definition Classes
      AnyRef → Any

33. #### def unapplyMember(tp: Global.Type): Global.Symbol

    Filters out unapplies with multiple (non-implicit) parameter lists, as they cannot be used as extractors

34. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

35. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

36. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

37. #### def →[B](y: B): (Unapplies, B)

    Implicit information
      This member is added by an implicit conversion from Unapplies to ArrowAssoc[Unapplies] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from TreeDSL

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Unapplies to any2stringadd[Unapplies]

### Inherited by implicit conversion StringFormat from Unapplies to StringFormat[Unapplies]

### Inherited by implicit conversion Ensuring from Unapplies to Ensuring[Unapplies]

### Inherited by implicit conversion ArrowAssoc from Unapplies to ArrowAssoc[Unapplies]

### Ungrouped